-- --------------------------------------------------------------------
-- @author: shiraho@syg.com(必填, 创建模块的人员)
-- @description:
--      任务和成就使用的单元
-- <br/>Create: new Date().toISOString()
--
-- --------------------------------------------------------------------
TaskItem = class("TaskItem", function()
    return ccui.Layout:create()
end)

function TaskItem:ctor()
    self.root_wnd = createCSBNote(PathTool.getTargetCSB("task/gw_task_item"))
    self.size = self.root_wnd:getContentSize()
    self:setAnchorPoint(cc.p(0.5, 0.5))
    self:setContentSize(self.size)

    self.root_wnd:setAnchorPoint(0.5, 0.5)
    self.root_wnd:setPosition(self.size.width * 0.5, self.size.height * 0.5)
    self:addChild(self.root_wnd)

    self.container = self.root_wnd:getChildByName("container")
    self.type1 = self.container:getChildByName("type1")
    self.type1_desc = self.type1:getChildByName("desc")
    self.type1_bar = self.type1:getChildByName("bar")
    self.type1_bar:setScale9Enabled(true)
    self.type1_bar_label = self.type1:getChildByName("bar_label")
    self.type1_goto_btn = self.type1:getChildByName("goto_btn")
    self.type1_goto_btn_label = self.type1_goto_btn:getChildByName("label")
    self.type1_goto_btn_label:setString(UI_TI18N(18008))
    self.type1_goto_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            if self.data ~= nil and self.data.config ~= nil then
                if self.data.finish == TaskConst.task_status.un_finish then
                    if self.data.progress ~= nil then
                        for i, v in ipairs(self.data.progress) do
                            if v.finish == FALSE then
                                TaskController:getInstance():handleTaskProgress(self.data, i)
                                break
                            end
                        end
                    end
                end
            end
        end
    end)
    self.type1:setVisible(false)
    self.type2 = self.container:getChildByName("type2")
    self.type2_desc = self.type2:getChildByName("desc")
    self.type2_get_btn = self.type2:getChildByName("get_btn")
    self.type2_get_btn_label = self.type2_get_btn:getChildByName("label")
    self.type2_get_btn_label:setString(UI_TI18N(18009))
    self.type2_get_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            if self.data ~= nil and self.data.config ~= nil then
                if self.data.finish == TaskConst.task_status.finish then
                    if self.data.type == TaskConst.type.quest or self.data.type == TaskConst.type.quest_week then
                        TaskController:getInstance():requestSubmitTask(self.data.id)
                    elseif self.data.type == TaskConst.type.feat then
                        TaskController:getInstance():requestSubmitFeat(self.data.id)
                    end
                end
            end
        end
    end)
    self.type2:setVisible(false)
    self.type3 = self.container:getChildByName("type3")
    self.type3_desc = self.type3:getChildByName("desc")
    self.type3_finish_btn = self.type3:getChildByName("finish_btn")
    self.type3_finish_btn_label = self.type3_finish_btn:getChildByName("label")
    self.type3_finish_btn_label:setString(UI_TI18N(18010))
    self.type3:setVisible(false)
    self.item_list = {}
    self.item_node = self.container:getChildByName("item_node")

    --self.btn_img_res = PathTool.getResFrame("common", "common_1098")
    --self.container = self.root_wnd:getChildByName("container")
    --self.task_desc = self.container:getChildByName("task_desc")
    --self.bar_value = self.container:getChildByName("bar_value")

    --self.btn_container = self.container:getChildByName("btn_container")

    --self.goto_btn = self.container:getChildByName("goto_btn")
    --self.goto_btn_label = self.goto_btn:getChildByName("label")
    --self.goto_btn_label:setString(TI18N("前往"))
    --self.get_btn = self.container:getChildByName("get_btn")
    --self.get_btn_label = self.get_btn:getChildByName("label")
    --self.get_btn_label:setString(TI18N("领取"))
    --self.finish_btn = self.container:getChildByName("finish_btn")
    --self.finish_btn_label = self.finish_btn:getChildByName("label")
    --self.finish_btn_label:setString(TI18N("已完成"))
    --
    --self.progress = self.container:getChildByName("progress")
    --self.progress:setScale9Enabled(true)
    --self.progress:setPercent( 0 )
    --self.value = self.container:getChildByName("bar_value")
    --self.value:setString(string.format("%s/%s", 0,0))
    --
    ----self.completed_img = self.container:getChildByName("completed_img")
    ----self.goods_con = self.container:getChildByName("goods_con")
    ----local scroll_view_size = self.goods_con:getContentSize()
    ----local setting = {
    ----    item_class = BackPackItem, -- 单元类
    ----    start_x = 0, -- 第一个单元的X起点
    ----    space_x = 8.5, -- x方向的间隔
    ----    start_y = 11, -- 第一个单元的Y起点
    ----    space_y = 4, -- y方向的间隔
    ----    item_width = BackPackItem.Width * 0.7, -- 单元的尺寸width
    ----    item_height = BackPackItem.Height * 0.7, -- 单元的尺寸height
    ----    row = 1, -- 行数，作用于水平滚动类型
    ----    col = 0, -- 列数，作用于垂直滚动类型
    ----    scale = 0.7
    ----}
    ----self.item_scrollview = CommonScrollViewLayout.new(self.goods_con,cc.p(0, 0),ScrollViewDir.horizontal,ScrollViewStartPos.top,scroll_view_size,setting)
    ----self.item_scrollview:setSwallowTouches(false)
    --
    --self.bg = self.container:getChildByName("bg")
    --self.goods_node = self.container:getChildByName("goods_node")
    --
    --
    --self.item_list = {}

    self:registerEvent()
end

function TaskItem:registerEvent()
    --self.goto_btn:addTouchEventListener(function(sender, event_type)
    --    customClickAction(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        if self.data ~= nil and self.data.config ~= nil then
    --            if self.data.finish == TaskConst.task_status.un_finish then
    --                if self.data.progress ~= nil then
    --                    for i, v in ipairs(self.data.progress) do
    --                        if v.finish == FALSE then
    --                            TaskController:getInstance():handleTaskProgress(self.data, i)
    --                            break
    --                        end
    --                    end
    --                end
    --            end
    --        end
    --    end
    --end)
    --self.get_btn:addTouchEventListener(function(sender, event_type)
    --    customClickAction(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        if self.data ~= nil and self.data.config ~= nil then
    --            if self.data.finish == TaskConst.task_status.finish then
    --                if self.data.type == TaskConst.type.quest or self.data.type == TaskConst.type.quest_week then
    --                    TaskController:getInstance():requestSubmitTask(self.data.id)
    --                elseif self.data.type == TaskConst.type.feat then
    --                    TaskController:getInstance():requestSubmitFeat(self.data.id)
    --                end
    --            end
    --        end
    --    end
    --end)

	-- 退出的时候移除一下吧.要不然可能有些人不会手动移除,就会报错
	self:registerScriptHandler(function(event)
		if "enter" == event then
		elseif "exit" == event then	
            if self.data ~= nil then
                if self.update_self_event ~= nil then
                    self.data:UnBind(self.update_self_event)
                    self.update_self_event = nil
                end
                self.data = nil
            end
		end 
	end)
end

function TaskItem:setData(data)
    --dump(data, "data = ", 8)
    if self.data ~= nil then
        if self.update_self_event ~= nil then
            self.data:UnBind(self.update_self_event)
            self.update_self_event = nil
        end
        self.data = nil
    end

    --引导需求
    self.type2_get_btn:setName("finish_btn_" .. data.id)

    self.data = data
    if self.update_self_event == nil then
        self.update_self_event = self.data:Bind(TaskEvent.UpdateSingleQuest, function() 
            self:updateSelf()
        end)
    end
    self:updateSelf()
    self:fillAwardsItems()
end

--[[
    @desc:创建展示物品
    author:{author}
    time:2018-05-26 13:56:08
    return
]]
function TaskItem:fillAwardsItems()
    if self.data == nil or self.data.config == nil or self.data.config.commit_rewards == nil then return end
    local list = {}
    for k, v in ipairs(self.data.config.commit_rewards) do
        local vo = deepCopy(Config.ItemData.data_get_data(v[1]))
        if vo then
            vo.quantity = v[2]
            table.insert(list, vo)
        end
    end

    self.item_list = self.item_list or {}
    for i,v in pairs(self.item_list) do
        v:setVisible(false)
    end
    if list ~= nil and next(list) ~= nil then
        for i,v in pairs(list) do
            if i>3 then break end

            if self.item_list[i] == nil then
                local item = GW_GoodsItem3.new(true,true,nil,0.8)
                item:setAnchorPoint(0.5, 0.5)
                item:setDefaultTip()
                item:setPosition(cc.p(0-120*(i-1),0))
                self.item_node:addChild(item)
                self.item_list[i] = item
            end

            self.item_list[i]:setData(v)
            self.item_list[i]:setVisible(true)
        end
    end

    --if list ~= nil and next(list) ~= nil and #list <= 2 then
    --    self.item_scrollview:setClickEnabled(false)
    --else
    --    self.item_scrollview:setClickEnabled(true)
    --end
    --self.item_scrollview:addEndCallBack(function()
    --    local list = self.item_scrollview:getItemList()
    --    for k, v in pairs(list) do
    --        v.effect = false
    --        v:setDefaultTip()
    --        v:setSwallowTouches(false)
    --    end
    --end)
    --self.item_scrollview:setData(list)
end

function TaskItem:updateSelf()
    if self.data == nil then return end
    self.id = self.data.id
    self.finish_sort = self.data.finish_sort

    self.type1:setVisible(false)
    self.type2:setVisible(false)
    self.type3:setVisible(false)

    if self.data.finish == TaskConst.task_status.un_finish then
        if self.data.progress ~= nil then
            local progress = self.data.progress[1]
            if progress ~= nil then
                if self.data.finish ~= TaskConst.task_status.completed then
                    self.type1_bar_label:setString(string.format("%s/%s", MoneyTool.GetMoneyString(progress.value), MoneyTool.GetMoneyString(progress.target_val)))
                    self.type1_bar:setPercent( 100 * progress.value/progress.target_val )
                else
                    self.type1_bar_label:setString(string.format("%s/%s", MoneyTool.GetMoneyString(progress.target_val), MoneyTool.GetMoneyString(progress.target_val)))
                    self.type1_bar:setPercent( 100 )
                end
            else
                self.type1_bar_label:setString(string.format("%s/%s", 1, 1))
                self.type1_bar:setPercent( 100 )
            end
        else
            self.type1_bar_label:setString(string.format("%s/%s", 1, 1))
            self.type1_bar:setPercent( 100 )
        end
        self.type1_desc:setString(self.data:getTaskContent())
        self.type1_desc:setFontSize(28)
        if self.type1_desc:getContentSize().width > 480 then
            for k=1,15 do
                self.type1_desc:setFontSize(28-k)
                if self.type1_desc:getContentSize().width <= 480 then
                    break
                end
            end
        end
        self.type1:setVisible(true)
    elseif self.data.finish == TaskConst.task_status.finish then
        self.type2_desc:setString(self.data:getTaskContent())
        self.type2_desc:setFontSize(28)
        if self.type2_desc:getContentSize().width > 400 then
            for k=1,15 do
                self.type2_desc:setFontSize(28-k)
                if self.type2_desc:getContentSize().width <= 400 then
                    break
                end
            end
        end
        self.type2:setVisible(true)
    else
        self.type3_desc:setString(self.data:getTaskContent())
        self.type3_desc:setFontSize(28)
        if self.type3_desc:getContentSize().width > 480 then
            for k=1,15 do
                self.type3_desc:setFontSize(28-k)
                if self.type3_desc:getContentSize().width <= 480 then
                    break
                end
            end
        end
        self.type3:setVisible(true)
    end

    --self.goto_btn:setVisible(false)
    --self.get_btn:setVisible(false)
    --self.finish_btn:setVisible(false)
    ----self.completed_img:setVisible(self.data.finish == TaskConst.task_status.completed)
    ----self.btn_container:setVisible(self.data.finish ~= TaskConst.task_status.completed)
    --
    ----local btn_img_res = PathTool.getResFrame("common", "common_1098")
    ----local outline_index = 167
    --if self.data.finish == TaskConst.task_status.un_finish then
    --    self.goto_btn:setVisible(true)
    --    --self.goto_btn_label:setString(TI18N("前往"))
    --    --self.goto_btn_label:enableOutline(cc.c4b(0x29, 0x4a, 0x15, 0xff),2)
    --elseif self.data.finish == TaskConst.task_status.finish then
    --    self.get_btn:setVisible(true)
    --else
    --    self.finish_btn:setVisible(true)
    --    --self.goto_btn_label:setString(TI18N("提交"))
    --    --btn_img_res = PathTool.getResFrame("common", "common_1027")
    --    --self.goto_btn_label:enableOutline(cc.c4b(0x76, 0x45, 0x19, 0xff),2)
    --end
    ----if self.btn_img_res ~= btn_img_res then
    ----    self.btn_img_res = btn_img_res
    ----    self.goto_btn:loadTexture(btn_img_res, LOADTEXT_TYPE_PLIST)
    ----end
    --
    ----if self.data.finish ~= TaskConst.task_status.completed then
    ----    if self.data.progress ~= nil then
    ----        local progress = self.data.progress[1]
    ----        if progress ~= nil then
    ----            self.value:setString(string.format("%s/%s", MoneyTool.GetMoneyString(progress.value), MoneyTool.GetMoneyString(progress.target_val)))
    ----            self.progress:setPercent( 100 * progress.value/progress.target_val )
    ----        end
    ----    end
    ----end

    --local bg_img_res = PathTool.getPlistImgForDownLoad("gw_task","gw_task_item_bg1")
    --if self.data.finish == TaskConst.task_status.completed then
    --    bg_img_res = PathTool.getPlistImgForDownLoad("gw_task","gw_task_item_bg2")
    --end
    --if self.bg_img_res ~= bg_img_res then
    --    self.bg_img_res = bg_img_res
    --    if self.bg_load then
    --        self.bg_load:DeleteMe()
    --        self.bg_load = nil
    --    end
    --    self.bg_load = loadImageTextureFromCDN(self.bg, bg_img_res, ResourcesType.single, self.bg_load)
    --end
    --
    --if self.data.progress ~= nil then
    --    local progress = self.data.progress[1]
    --    if progress ~= nil then
    --        if self.data.finish ~= TaskConst.task_status.completed then
    --            self.value:setString(string.format("%s/%s", MoneyTool.GetMoneyString(progress.value), MoneyTool.GetMoneyString(progress.target_val)))
    --            self.progress:setPercent( 100 * progress.value/progress.target_val )
    --        else
    --            self.value:setString(string.format("%s/%s", MoneyTool.GetMoneyString(progress.target_val), MoneyTool.GetMoneyString(progress.target_val)))
    --            self.progress:setPercent( 100 )
    --        end
    --    else
    --        self.value:setString(string.format("%s/%s", 1, 1))
    --        self.progress:setPercent( 100 )
    --    end
    --end
    --self.task_desc:setString(self.data:getTaskContent())
end

function TaskItem:suspendAllActions()
    if self.data ~= nil then
        if self.update_self_event ~= nil then
            self.data:UnBind(self.update_self_event)
            self.update_self_event = nil
        end
        self.data = nil
    end
end

function TaskItem:DeleteMe()
    if self.item_list ~= nil then
        for i,v in ipairs(self.item_list) do
            v:DeleteMe()
        end
        self.item_list = nil
    end

    if self.data ~= nil then
        if self.update_self_event ~= nil then
            self.data:UnBind(self.update_self_event)
            self.update_self_event = nil
        end
        self.data = nil
    end
    self:removeAllChildren()
    self:removeFromParent()
end